commit cc11a171eee059b645870f2e208c530f301239c9
Author: Kewen Lin <linkw@linux.ibm.com>
Date:   Wed Sep 22 02:13:57 2021

    ipa-fnsummary: Remove inconsistent bp_pack_value
    
    There is one inconsistent bit-field streaming out and in.
    On the side of streaming in:
    
        bp_pack_value (&bp, info->inlinable, 1);
        bp_pack_value (&bp, false, 1);
        bp_pack_value (&bp, info->fp_expressions, 1);
    
    while on the side of the streaming out:
    
        info->inlinable = bp_unpack_value (&bp, 1);
        info->fp_expressions = bp_unpack_value (&bp, 1)
    
    The removal of Cilk Plus support r8-4956 missed to remove
    the streaming out of the bit, instead just change the value
    for streaming out to be always false.
    
    By hacking fp_expression_p to always return true, I can see
    it reads the wrong fp_expressions value (false) out in wpa.
    
    GCC12 adopts commit 63c6446f77b9001d26f973114450d790749f282b
    which removes the inconsistent streaming out instead.
    
    gcc/ChangeLog:
    
            * ipa-fnsummary.c (inline_read_section): Unpack a dummy bit
            to keep consistent with the side of streaming out.

diff --git a/gcc/ipa-fnsummary.c b/gcc/ipa-fnsummary.c
index 18bbae145b9..bf635c1f78a 100644
--- a/gcc/ipa-fnsummary.c
+++ b/gcc/ipa-fnsummary.c
@@ -4403,13 +4403,20 @@ inline_read_section (struct lto_file_decl_data *file_data, const char *data,
       bp = streamer_read_bitpack (&ib);
       if (info)
 	{
-          info->inlinable = bp_unpack_value (&bp, 1);
-          info->fp_expressions = bp_unpack_value (&bp, 1);
+	  info->inlinable = bp_unpack_value (&bp, 1);
+	  /* On the side of streaming out, there is still one bit
+	     streamed out between inlinable and fp_expressions bits,
+	     which was used for cilk+ before but now always false.
+	     To remove the bit packing need to bump LTO minor version,
+	     so unpack a dummy bit here to keep consistent instead.  */
+	  bp_unpack_value (&bp, 1);
+	  info->fp_expressions = bp_unpack_value (&bp, 1);
 	}
       else
 	{
-          bp_unpack_value (&bp, 1);
-          bp_unpack_value (&bp, 1);
+	  bp_unpack_value (&bp, 1);
+	  bp_unpack_value (&bp, 1);
+	  bp_unpack_value (&bp, 1);
 	}
 
       count2 = streamer_read_uhwi (&ib);

